#!/bin/sh
#
#   ua.com 
#   
#   tested for SGI IRIX 5.3, I-DEAS MS 3, MS 4
#   tested for HP-UX 9.05
#
# Defaulteinstellungen
#
ideas_grafik_device="PEX"
#
# Ermittlung der I-DEAS IDM Informationen
# 
mode=$1
project_name=`cat idminfo.2d3d | sed -n "1,1 p" | awk -F":" '{print $3}'`
model_name=`cat idminfo.2d3d | sed -n "2,2 p" | awk -F":" '{print $3}'`
layout_name=`cat idminfo.2d3d | sed -n "3,3 p" | awk -F":" '{print $3}'`
part_number=`cat idminfo.2d3d | sed -n "4,4 p" | awk -F":" '{print $3}'`
version=`cat idminfo.2d3d | sed -n "5,5 p" | awk -F":" '{print $3}'`
#
# Headder - Info
echo "------- ua.com ----------------------"
#  
# Check ob I-DEAS interaktiv oder im Batch laufen soll
# Wenn Batch, wird eine Eingabedatei fuer ideasb erstellt
#
if [ "$mode" = "-b" ]; then
	echo ".... Generating ideasbatch.input"
	echo $ideas_grafik_device  > ideasbatch.input
	echo "action.prg"         >> ideasbatch.input
	echo $project_name        >> ideasbatch.input
	echo $model_name          >> ideasbatch.input
	echo "design"             >> ideasbatch.input
	echo "mm"                 >> ideasbatch.input
fi
#
# Generierung des I-DEAS Macros action.prg 
#
# awk - procedure ------------------------------------------------
cat idminfo.2d3d | sed -n "6,$ p" | grep -n ":" | awk 'BEGIN {FS = ":"
print "C : "
print "C : ______________________________________________________"
# Externe Variablen in awk bekanntmachen
project_name = "'$project_name'"
model_name= "'$model_name'"
layout_name= "'$layout_name'"
part_number= "'$part_number'"
mode="'$mode'"
    print "C : #ECHO NONE"
    print "K : $ /MA IT"
    print "C : Set Context zu aktuellem Project (C : Current Project)"
    print "K :  SC C "
    print "C : Filter setzen auf Model File"
    print "K :  FS O FLT C QG T HI TA 3;"
    print "K :  P I "model_name
    print "K : OKAY"
    print "C : Set Context Selected_Items; Bezug auf Model File umstellen"
    print "K :  IS 1;"
    print "K :  SC SI"
    print "C : Filter auf Drafting setzen"
    print "K :  FS O FLT C QG T HI TA 3;"
    print "K :  P I "layout_name
    print "K : OKAY"
    print "K :  IS 1;"
    print "K :  DET U"
    print "C : Loeschen aller UA bis zum Ende"
    print "K : #LOESCH_LABEL:"
    print "K : ALV"
    print "K : 1"
    print "K : d"
    print "K : DEL"
    print "K : #IF (z_error ne 1) then goto LOESCH_LABEL"
    print "K : OKAY"
    print "C : Ende Loeschen der UAs"
# Generating I-DEAS Macro: 
}
#
# Schleife die alle User Attribute abarbeitet
#
{
# Interne Variablen
UA_index = $1
UA_label = $2
UA_typ   = $3
UA_wert  = $4
if (UA_typ=="C") then (UA_typ_id=1)
if (UA_typ=="R") then (UA_typ_id=4)
if (UA_typ=="I") then (UA_typ_id=3)
#
# Generating I-DEAS Macro: Kopieren und Bennennen von Standardteil
#
    print "C : -------- "UA_index". UA :"UA_label"------------------"
    print "K : #OUTPUT \"Setting "UA_index". UA "UA_label" : "UA_wert"\""
    print "K : DET U "
    print "K : ALA"
    print "K : "UA_label
    print "K : UAT"
    print "K : " UA_typ_id
    print "K : d okay"
    print "K : Appl"
    print "K : ALV"
    print "K : " UA_index
    print "K : d"
    print "K : AVA"
    print "K : "UA_wert
    print "K : MOD Appl Okay"
}
# Ende der Datensaetze
END {
print "K : CANC"
print "K : #ECHO ALL"
# wenn Batch Betrieb, fuege I-DEAS Befehl fuer SAVE und EXIT hinzu
if (mode=="-b")
    {print "K : $ / F EXIT YES" }
if (mode=="-b") then (id=2 )
print "E :" }' | cut -c1-120 > action.prg
#------------- ENDE AWK-Prozedur ------------------------------
#
# Starten von I-DEAS Batch
#
if [ "$mode" = "-b" ]; then
	echo "Starting I-DEAS in batch mode"
	ideasb < ideasbatch.input
fi

