//***********************************************************************<NP>
// O------------------------------------------------------------------------O
// | Include    : Headinfo (Informationen ueber bekannte Zeichnungskoepfe)  |
// U------------------------------------------------------------------------U
// Author       : P. Artmann (ArP)           Datum : 22.12.1997
// Bearbeiter   :
// akt. Stand   : 22.12.1997
// --------------------------------------------------------------------------
// Beschreibung :  Dieser Include beinhaltet Informationen ueber die
// --------------  im System bekannten Zeichnungskoepfe.
//***************************************************************************
//
HeadTest = false               // switch for Testing Header-Functions
//
// HeadGroup : hier muessen alle Zeichnungskoepfe sowie deren Groesse
//             eingetragen werden
// Format : 
// "Zeichnungskopfname" { "Formularname" { Breite, Hoehe } }
//
HeadGroup = { 
"a0_land"   { "a0"   { 1189,  841 } } 
"a0_port"   { "a0"   {  841, 1189 } } 
"a1_land"   { "a1"   {  841,  594 } } 
"a1_port"   { "a1"   {  594,  841 } } 
"a2_land"   { "a2"   {  594,  420 } } 
"a2_port"   { "a2"   {  420,  594 } } 
"a3_land"   { "a3"   {  420,  297 } } 
"a3_port"   { "a3"   {  297,  420 } } 
"a4_land"   { "a4"   {  297,  210 } } 
"a4_port"   { "a4"   {  210,  297 } } 
"a5_land"   { "a5"   {  210,  148 } } 
"a5_port"   { "a5"   {  148,  210 } } 
"a11a_land" { "a11a" {  280,  215 } } 
"a11a_port" { "a11a" {  215,  280 } } 
"a11b_land" { "a11b" {  432,  280 } } 
"a11b_port" { "a11b" {  280,  432 } } 
"a11c_land" { "a11c" {  559,  432 } } 
"a11c_port" { "a11c" {  432,  559 } } 
"a11d_land" { "a11d" {  864,  559 } } 
"a11d_port" { "a11d" {  559,  864 } } 
"a11e_land" { "a11e" { 1118,  864 } } 
"a11e_port" { "a11e" {  864, 1118 } } 
"a12a_land" { "a12a" {  305,  229 } } 
"a12a_port" { "a12a" {  229,  305 } } 
"a12b_land" { "a12b" {  457,  305 } } 
"a12b_port" { "a12b" {  305,  457 } } 
"a12c_land" { "a12c" {  610,  457 } } 
"a12c_port" { "a12c" {  457,  610 } } 
"a12d_land" { "a12d" {  914,  610 } } 
"a12d_port" { "a12d" {  610,  914 } } 
"a12e_land" { "a12e" { 1219,  914 } } 
"a12e_port" { "a12e" {  914, 1219 } } 
}

